---
schema_version: "1"
id: 93402de1258ab7705008be018cbf2152f37f343ecbb7f9677b1cd0cd20bf1e41
title: Data Sources Methods
collection: tableau
version: next
locale: en-us
portal_url: https://docs.salesforce.com/tableau/next/en-us/api/rest_api/REST/rest_api_ref_data_sources.md
canonical_url: https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm
source_site: help.tableau.com
content_type: documentation
content_hash: 11c7ff3e79ea4130490050501397e9ebfe8a84ac36ad3cf0b3e5577c27d8c4ac
description: "Using the data sources methods of the Tableau Server REST API you can:"
---
[Skip to main content](#main-content)

# Data Sources Methods

Using the data sources methods of the Tableau Server REST API you can:

- Publish, update metadata, delete, or refresh the extract of a data source of a site
- Add and delete tags of a data source
- Get a list of data sources and the details of each
- Get and update the connection information for a data source
- Get the revision history of a data source or remove specific revisions
- Download the current data source or one of its past revisions
- Incrementally update specified portions of data from a live-to-Hyper connection.
- Download an encrypted keychain for a data source that is migrating to another site.
- Upload an encrypted keychain for a data source migrated to another site.
- Create a work copy of a published data source, read and edit its elements, and publish the changes

This functionality relates to the UI elements and concepts described at: [Connect to Your Data](https://help.tableau.com/current/pro/desktop/en-us/basicconnectoverview.htm).

  
  

The [Tableau Server Client library](https://tableau.github.io/server-client-python/), a Python wrapper for the REST API, offers the following related items: [Data Sources](https://tableau.github.io/server-client-python/docs/api-ref#data-sources); and [Populate connections for Data Sources](https://tableau.github.io/server-client-python/docs/populate-connections-views#populate-connections-for-data-sources).

## Use Postman

Our Postman collection of requests enables you to construct, send, and examine HTTP requests to the Tableau Server or Tableau Cloud API without writing initial code. Postman is a free online app used by many developers for prototyping API calls, investigating issues, and generating request code in a variety of languages.

[Postman: Data Sources](https://www.postman.com/salesforce-developers/salesforce-developers/folder/gl07jsz/data-sources)

## Add Tags to Data Source

Adds one or more tags to the specified data source.

#### URI

PUT /api/api-version/sites/site-id/datasources/datasource-id/tags

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to add tags to.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tags>
    <tag label="tag" />
    ... additional tags ...
  </tags>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">datasource-id</span></td><td>The data source to add the tag to. If the data source is already tagged with a tag that's included in the request body, those tags are ignored and the data source retains them. If the <span class="api-command-ref">&lt;tags&gt;</span> element is empty, no new tags are added to the data source.</td></tr><tr><td><span class="api-placeholder">tag</span></td><td>The text of the tag.</td></tr></tbody></table>

#### Permissions

Tableau Server users who are not server administrators or site administrators can call this method only if they have Read permissions for the data source (either explicitly or implicitly).

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:datasource_tags:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

```
<tsResponse>
  <tags>
    <tag label="tag"/>
        ... additional new tags ...
        ... existing tags ...
  </tags>
</tsResponse>
```

#### Version

Version 1.0 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table">
                                <colgroup>
                                    <col class="api-error-table-col-1">
                                    <col class="api-error-table-col-2">
                                    <col class="api-error-table-col-3">
                                    <col>
                                </colgroup>
                                <tbody>
                                    <tr>
                                        <th>HTTP status</th>
                                        <th><code>error</code> Code</th>
                                        <th>Condition</th>
                                        <th>Details</th>
                                    </tr>
                                    <tr>
                                        <td>400</td>
                                        <td>400000</td>
                                        <td>Bad request</td>
                                        <td>The content of the request body is missing or incomplete, or contains malformed XML.</td>
                                    </tr>
                                    <tr>
                                        <td>400</td>
                                        <td>400075</td>
                                        <td>Error adding tags</td>
                                        <td>There was a problem adding tags to the specified data source.</td>
                                    </tr>
                                    <tr>
                                        <td>403</td>
                                        <td>403004</td>
                                        <td>Adding tags forbidden</td>
                                        <td>
                                            <p>
                                            A non-administrator user called this method but doesn't have permission to add tags. This error is raised even if
                                            the <span class="api-command-ref">&lt;tags&gt;</span> element is empty.
                                        </p>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td>404000</td>
                                        <td>Site not found</td>
                                        <td>
                                            <p>The site ID in the URI is not for an existing site.</p>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td>404004</td>
                                        <td>Data source not found</td>
                                        <td>The data source ID in URI doesn't correspond to an existing data source.</td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td>404009</td>
                                        <td>Data source ID mismatch</td>
                                        <td>The request body contains a data source ID (which is optional) and it doesn't match the ID in the URI.</td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td>405000</td>
                                        <td>Invalid request method</td>
                                        <td>Request type was not <span class="api-command-ref">PUT</span>.</td>
                                    </tr>
                                </tbody>
                            </table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

#### Example

`curl "http://MY-SERVER/api/3.29/sites/9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d/datasources/1a2a3b4b-5c6c-7d8d-9e0e-1f2f3a4a5b6b/tags" -X PUT -H "X-Tableau-Auth:12ab34cd56ef78ab90cd12ef34ab56cd" -d @add-tags-to-datasource.xml`

**Content of add-tags-to-datasource.xml:**

```
<tsRequest>
    <tags>
      <tag label="GDP" />
      <tag label="Health" />
    </tags>
</tsRequest>
```

**Example response:**

```
<tsResponse version-and-namespace-settings>
  <tags>
    <tag label="GDP"/>
    <tag label="Health"/>
    <tag label="Spending"/>
  </tags>
</tsResponse>
```

## Add Work Copy Elements

Adds field descriptions or table descriptions to a work copy. Returns HTTP 201 when every element is added. The success body omits the elements that succeeded.

If any element fails, the HTTP status is the status of the first failure and the body lists only the failed elements. A `Column` entry is not added by this method.

**Version**: Available in API 3.30 (Tableau Cloud October 2026 / Server 2026.3) and later.

**License**: Data Management or Tableau+.

**Permissions**: Users who are not server administrators or site administrators can call this method only if they have Connect, Write (save), and VizqlDataApiAccess (API Access) permissions for the data source that the work copy was created from (either explicitly or implicitly).

**Access Scope**: `tableau:datasources:update`

For more information, see [Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm), [Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm), [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud), and access scopes for [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows,](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm) or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### URI

POST /api/api-version/tds/sites/site-luid/workcopy/workcopy-luid

#### URI Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use. These TDS Edit methods are available in API 3.30 and later. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site in the URI. This handler does not bind the path variable — the service uses the authenticated user's site LUID (<code>authUser.getSiteLuid()</code>).</td></tr><tr><td><span class="api-placeholder">workcopy-luid</span></td><td>The LUID of the work copy. Must be a UUID (8-4-4-4-12 hexadecimal digits), matching <code>[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}</code>.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tdsElementList>
    <elementType>FieldDescription</elementType>
    <name>Sales</name>
    <description>Total sales amount.</description>
  </tdsElementList>
  <tdsElementList>
    <elementType>TableDescription</elementType>
    <name>Orders</name>
    <description>Order line items.</description>
  </tdsElementList>
</tsRequest>
```

```
{
  "tdsElementList": [
    {
      "elementType": "FieldDescription",
      "name": "Sales",
      "description": "Total sales amount."
    },
    {
      "elementType": "TableDescription",
      "name": "Orders",
      "description": "Order line items."
    }
  ]
}
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tdsElementList[]</span></td><td>Required. Elements to add. Must contain at least one element. An empty or missing list is HTTP 400 with error code <code>400008</code>.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].elementType</span></td><td>Optional. Element type sent to the TDS service. For this operation, use <code>FieldDescription</code> or <code>TableDescription</code>. Any other value is forwarded and reported as a per-element failure.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].name</span></td><td>Required. Element name.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].column</span></td><td>Not applicable to this method. The add converter has no <code>Column</code> branch, so a <code>column</code> payload on an add element is not copied and the element is reported as a per-element failure.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].description</span></td><td>Required for this method. Description text for a <code>FieldDescription</code> or <code>TableDescription</code> element. When <code>description</code> is null, the field is left unset so the TDS service can report a per-element failure instead of HTTP 500.</td></tr></tbody></table>

#### Response Code

201 Created

#### Response Body

On full success the response is an empty `tsResponse` — `tdsElementResult` is omitted entirely rather than returned as an empty list. When one or more elements fail, the HTTP status is the status of the first failure and the body carries `tdsElementResult` for the failed elements only; see the Attribute Values table below and the Errors table for the failure shape.

```
<tsResponse/>
```

```
{}
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tdsElementResult[]</span></td><td>Failed elements only. Omitted on full success, including omitted rather than returned as an empty array.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].elementType</span></td><td>Required. Element type of the failed element, copied from the request.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].name</span></td><td>Required. Name of the failed element, copied from the request.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status</span></td><td>Required. Failure status for this element.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status.code</span></td><td>Required (within <code>status</code>). The translated HTTP status for this element (200, 400, 401, 403, 404, 409, 500, or 503). Not a Tableau 6-digit error sub-code.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status.message</span></td><td>Optional. Error message from the TDS service.</td></tr></tbody></table>

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400008</td><td>Missing tdsElementList</td><td><code>tdsElementList</code> is missing or empty. The list is required and must contain at least one element.</td></tr><tr><td>400</td><td></td><td>Invalid work copy LUID</td><td>The work copy LUID in the URI is not a UUID (8-4-4-4-12 hexadecimal digits).</td></tr><tr><td>400</td><td></td><td>Per-element invalid argument</td><td>One or more elements were rejected as invalid. The body lists only the failed elements, and each <code>status.code</code> is the HTTP status 400.</td></tr><tr><td>400</td><td></td><td>Unmapped per-element gRPC status</td><td>The TDS service returned a status that maps to HTTP 400. The body lists only the failed elements.</td></tr><tr><td>401</td><td>401000 / 401002</td><td>Missing or invalid authentication</td><td>No authentication token provided, or token is expired or invalid.</td></tr><tr><td>401</td><td></td><td>Per-element unauthenticated</td><td>The TDS service rejected an element as unauthenticated. The body lists only the failed elements.</td></tr><tr><td>403</td><td>403004</td><td>Data Management Bundle not licensed</td><td>On Tableau Server the TDS Edit API requires a Data Management Bundle license. The call is rejected when that license is absent.</td></tr><tr><td>403</td><td>403004</td><td>Unable to resolve tenant</td><td>On Tableau Cloud the subscription could not be checked because the tenant id for the site could not be retrieved.</td></tr><tr><td>403</td><td>403004</td><td>No cloud entitlements</td><td>On Tableau Cloud no entitlements were found for the tenant. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>403</td><td>403004</td><td>Subscription not entitled</td><td>On Tableau Cloud the site edition is not Tableau+. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>403</td><td></td><td>Per-element permission denied</td><td>The TDS service rejected an element because permission was denied. The body lists only the failed elements.</td></tr><tr><td>404</td><td></td><td>Per-element not found</td><td>One or more elements were not found. The body lists only the failed elements. This is not error code 404065, which the read methods return for a missing named element.</td></tr><tr><td>405</td><td>405000</td><td>Method not allowed</td><td>The HTTP method is not supported for this resource.</td></tr><tr><td>409</td><td></td><td>Per-element already exists</td><td>One or more elements already exist. The body lists only the failed elements.</td></tr><tr><td>429</td><td>429000</td><td>Rate limit exceeded</td><td>Too many requests sent in a given time period.</td></tr><tr><td>500</td><td></td><td>Per-element internal error</td><td>The TDS service failed while editing an element. The body lists only the failed elements.</td></tr><tr><td>503</td><td></td><td>Per-element unavailable</td><td>The TDS service was unavailable while editing an element. The body lists only the failed elements.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Create Work Copy

Creates a work copy of a published data source and returns the work copy LUID. Composable data sources and Semantic Data Model (SDM) data sources are not supported. The call is rejected when the caller already has the maximum number of open work copies.

**Version**: Available in API 3.30 (Tableau Cloud October 2026 / Server 2026.3) and later.

**License**: Data Management or Tableau+.

**Permissions**: Users who are not server administrators or site administrators can call this method only if they have Connect, Write (save), and VizqlDataApiAccess (API Access) permissions for the data source (either explicitly or implicitly).

**Access Scope**: `tableau:datasources:create`

For more information, see [Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm), [Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm), [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud), and access scopes for [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows,](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm) or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### URI

POST /api/api-version/tds/sites/site-luid/datasource/datasource-luid/workcopy

#### URI Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use. These TDS Edit methods are available in API 3.30 and later. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site in the URI. This handler does not bind the path variable — the service uses the authenticated user's site LUID (<code>authUser.getSiteLuid()</code>).</td></tr><tr><td><span class="api-placeholder">datasource-luid</span></td><td>The LUID of the data source. Must be a UUID (8-4-4-4-12 hexadecimal digits), matching <code>[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}</code>.</td></tr></tbody></table>

#### Response Code

201 Created

#### Response Body

Returns the created work copy's identifiers in `tdsWorkCopy`. The response includes `workCopyLuid` but not `datasourceLuid`, which only Publish Work Copy returns.

```
<tsResponse>
  <tdsWorkCopy>
    <workCopyLuid>d9e8f7a6-b5c4-3210-fedc-ba9876543210</workCopyLuid>
  </tdsWorkCopy>
</tsResponse>
```

```
{
  "tdsWorkCopy": {
    "workCopyLuid": "d9e8f7a6-b5c4-3210-fedc-ba9876543210"
  }
}
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tdsWorkCopy</span></td><td>Required. Work copy identifiers.</td></tr><tr><td><span class="api-placeholder">tdsWorkCopy.workCopyLuid</span></td><td>LUID of the new work copy.</td></tr><tr><td><span class="api-placeholder">tdsWorkCopy.datasourceLuid</span></td><td>Optional. LUID of the published data source. Not returned by this method; returned by Publish Work Copy.</td></tr></tbody></table>

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td></td><td>Invalid data source LUID</td><td>The data source LUID in the URI is not a UUID (8-4-4-4-12 hexadecimal digits).</td></tr><tr><td>401</td><td>401000 / 401002</td><td>Missing or invalid authentication</td><td>No authentication token provided, or token is expired or invalid.</td></tr><tr><td>403</td><td>403004</td><td>Data Management Bundle not licensed</td><td>On Tableau Server the TDS Edit API requires a Data Management Bundle license. The call is rejected when that license is absent.</td></tr><tr><td>403</td><td>403004</td><td>Unable to resolve tenant</td><td>On Tableau Cloud the subscription could not be checked because the tenant id for the site could not be retrieved.</td></tr><tr><td>403</td><td>403004</td><td>No cloud entitlements</td><td>On Tableau Cloud no entitlements were found for the tenant. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>403</td><td>403004</td><td>Subscription not entitled</td><td>On Tableau Cloud the site edition is not Tableau+. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>404</td><td></td><td>Data source not found or not visible to the caller</td><td>The data source LUID in the URI doesn't correspond to an existing data source in the site, or the caller doesn't have permission to access it.</td></tr><tr><td>405</td><td>405000</td><td>Method not allowed</td><td>The HTTP method is not supported for this resource.</td></tr><tr><td>405</td><td>405003</td><td>Composable data source</td><td>Creating a work copy is not supported for composable data sources (data sources that have one or more immediate parent published data sources).</td></tr><tr><td>405</td><td>405004</td><td>Semantic Data Model (SDM) data source</td><td>Creating a work copy is not supported for Semantic Data Model (SDM) data sources.</td></tr><tr><td>429</td><td>429000</td><td>Rate limit exceeded</td><td>Too many requests sent in a given time period.</td></tr><tr><td>429</td><td></td><td>Work copy limit exceeded</td><td>The maximum number of open work copies is reached. Publish an existing work copy before creating a new one.</td></tr><tr><td>500</td><td></td><td>Unknown error</td><td>There was an internal server error.</td></tr><tr><td>503</td><td></td><td>Service unavailable</td><td>Service unavailable.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Delete Data Source

Deletes the specified data source from a site. When a data source is deleted, its associated data connection is also deleted. Workbooks that use the data source are not deleted, but they will no longer work properly.

#### URI

DELETE /api/api-version/sites/site-id/datasources/datasource-id

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to delete.</td></tr></tbody></table>

#### Request Body

None

#### Permissions

Tableau Server users who are not server administrators or site administrators can delete a data source for which they have Read (view) and Delete permissions (either explicitly or implicitly).

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:datasources:delete
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

204

#### Response Body

None

#### Version

Version 2.0 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>403</td><td>403004</td><td>Deletion forbidden</td><td>A non-administrator user called this method but doesn't have <span class="api-command-ref">Read</span> (view) and <span class="api-command-ref">Delete</span> permission for the data source.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID or URL namespace in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404004</td><td>Data source not found</td><td>The data source ID in the URI doesn't correspond to an existing data source in the site.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">DELETE</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Delete Tag from Data Source

Deletes a tag from the specified data source.

#### URI

DELETE /api/api-version/sites/site-id/datasources/datasource-id/tags/tag-name

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to remove the tag from.</td></tr><tr><td><span class="api-placeholder">tag-name</span></td><td>The name of the tag to remove from the data source.</td></tr></tbody></table>

#### Request Body

None

#### Permissions

Tableau Server users who are not server administrators, site administrators, or data source owners can delete a tag from a data source only if they are project leaders or if they originally added the tag.

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:datasource_tags:delete
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

204

#### Response Body

None

#### Version

Version 1.0 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400077</td><td>Error deleting tag</td><td>There was a problem deleting the tag from the specified data source.</td></tr><tr><td>403</td><td>403004</td><td>Deleting tags forbidden</td><td>A non-administrator user called this method but doesn't have permission to delete a tag from the specified data source.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID or URL namespace in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404004</td><td>Data source not found</td><td>The data source ID in the URI doesn't correspond to an existing data source.</td></tr><tr><td>404</td><td>404007</td><td>Tag not found</td><td>The tag in the URI doesn't exist for the specified data source.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">DELETE</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Delete Work Copy Elements

Deletes elements from a work copy. Send `elementType` and `name` for each element. Other content is ignored. Returns HTTP 200 when every element is deleted. The success body omits the elements that succeeded.

If any element fails, the HTTP status is the status of the first failure and the body lists only the failed elements.

**Version**: Available in API 3.30 (Tableau Cloud October 2026 / Server 2026.3) and later.

**License**: Data Management or Tableau+.

**Permissions**: Users who are not server administrators or site administrators can call this method only if they have Connect, Write (save), and VizqlDataApiAccess (API Access) permissions for the data source that the work copy was created from (either explicitly or implicitly).

**Access Scope**: `tableau:datasources:update`

For more information, see [Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm), [Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm), [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud), and access scopes for [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows,](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm) or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### URI

DELETE /api/api-version/tds/sites/site-luid/workcopy/workcopy-luid

#### URI Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use. These TDS Edit methods are available in API 3.30 and later. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site in the URI. This handler does not bind the path variable — the service uses the authenticated user's site LUID (<code>authUser.getSiteLuid()</code>).</td></tr><tr><td><span class="api-placeholder">workcopy-luid</span></td><td>The LUID of the work copy. Must be a UUID (8-4-4-4-12 hexadecimal digits), matching <code>[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}</code>.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tdsElementList>
    <elementType>FieldDescription</elementType>
    <name>Sales</name>
  </tdsElementList>
  <tdsElementList>
    <elementType>TableDescription</elementType>
    <name>Orders</name>
  </tdsElementList>
</tsRequest>
```

```
{
  "tdsElementList": [
    {
      "elementType": "FieldDescription",
      "name": "Sales"
    },
    {
      "elementType": "TableDescription",
      "name": "Orders"
    }
  ]
}
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tdsElementList[]</span></td><td>Required. Elements to delete. Must contain at least one element. An empty or missing list is HTTP 400 with error code <code>400008</code>.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].elementType</span></td><td>Required for this method. Element type of the element to delete (<code>Column</code>, <code>FieldDescription</code>, or <code>TableDescription</code>). Any other value is forwarded and reported as a per-element failure.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].name</span></td><td>Required. Name of the element to delete.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].column</span></td><td>Not applicable to this method. Delete uses <code>elementType</code> and <code>name</code> only; other content is ignored.</td></tr><tr><td><span class="api-placeholder">tdsElementList[].description</span></td><td>Not applicable to this method. Delete uses <code>elementType</code> and <code>name</code> only; other content is ignored.</td></tr></tbody></table>

#### Response Code

200 OK

#### Response Body

On full success the response is an empty `tsResponse` — `tdsElementResult` is omitted entirely rather than returned as an empty list. When one or more elements fail, the HTTP status is the status of the first failure and the body carries `tdsElementResult` for the failed elements only; see the Attribute Values table below and the Errors table for the failure shape.

```
<tsResponse/>
```

```
{}
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tdsElementResult[]</span></td><td>Failed elements only. Omitted on full success, including omitted rather than returned as an empty array.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].elementType</span></td><td>Required. Element type of the failed element, copied from the request.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].name</span></td><td>Required. Name of the failed element, copied from the request.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status</span></td><td>Required. Failure status for this element.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status.code</span></td><td>Required (within <code>status</code>). The translated HTTP status for this element (200, 400, 401, 403, 404, 500, or 503). Not a Tableau 6-digit error sub-code.</td></tr><tr><td><span class="api-placeholder">tdsElementResult[].status.message</span></td><td>Optional. Error message from the TDS service.</td></tr></tbody></table>

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400008</td><td>Missing tdsElementList</td><td><code>tdsElementList</code> is missing or empty. The list is required and must contain at least one element.</td></tr><tr><td>400</td><td></td><td>Invalid work copy LUID</td><td>The work copy LUID in the URI is not a UUID (8-4-4-4-12 hexadecimal digits).</td></tr><tr><td>400</td><td></td><td>Per-element invalid argument</td><td>One or more elements were rejected as invalid. The body lists only the failed elements, and each <code>status.code</code> is the HTTP status 400.</td></tr><tr><td>400</td><td></td><td>Unmapped per-element gRPC status</td><td>The TDS service returned a status that maps to HTTP 400. The body lists only the failed elements.</td></tr><tr><td>401</td><td>401000 / 401002</td><td>Missing or invalid authentication</td><td>No authentication token provided, or token is expired or invalid.</td></tr><tr><td>401</td><td></td><td>Per-element unauthenticated</td><td>The TDS service rejected an element as unauthenticated. The body lists only the failed elements.</td></tr><tr><td>403</td><td>403004</td><td>Data Management Bundle not licensed</td><td>On Tableau Server the TDS Edit API requires a Data Management Bundle license. The call is rejected when that license is absent.</td></tr><tr><td>403</td><td>403004</td><td>Unable to resolve tenant</td><td>On Tableau Cloud the subscription could not be checked because the tenant id for the site could not be retrieved.</td></tr><tr><td>403</td><td>403004</td><td>No cloud entitlements</td><td>On Tableau Cloud no entitlements were found for the tenant. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>403</td><td>403004</td><td>Subscription not entitled</td><td>On Tableau Cloud the site edition is not Tableau+. The TDS Edit API requires a Tableau+ subscription.</td></tr><tr><td>403</td><td></td><td>Per-element permission denied</td><td>The TDS service rejected an element because permission was denied. The body lists only the failed elements.</td></tr><tr><td>404</td><td></td><td>Per-element not found</td><td>One or more elements were not found. The body lists only the failed elements. This is not error code 404065, which the read methods return for a missing named element.</td></tr><tr><td>405</td><td>405000</td><td>Method not allowed</td><td>The HTTP method is not supported for this resource.</td></tr><tr><td>429</td><td>429000</td><td>Rate limit exceeded</td><td>Too many requests sent in a given time period.</td></tr><tr><td>500</td><td></td><td>Per-element internal error</td><td>The TDS service failed while editing an element. The body lists only the failed elements.</td></tr><tr><td>503</td><td></td><td>Per-element unavailable</td><td>The TDS service was unavailable while editing an element. The body lists only the failed elements.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Download Data Source

Downloads a data source in `.tdsx` format.

#### URI

GET /api/api-version/sites/site-id/datasources/datasource-id/content

GET /api/api-version/sites/site-id/datasources/datasource-id/content?includeExtract=extract-value

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to download.</td></tr><tr><td><span class="api-placeholder">extract-value</span></td><td>(Optional) The <span class="api-placeholder">extract-value</span> is a Boolean value (<code>False</code> or <code>True</code>). When the data source specified for download has an extract, if you add the parameter <code>?includeExtract=False</code>, the extract is not included when you download the data source. You can use this parameter to improve performance if you are downloading workbooks or data sources that have large extracts.</td></tr></tbody></table>

#### Request Body

None

#### Permissions

Users who are not server administrators or site administrators can download a data source only if they have ExportXml permission for the data source (either explicitly or implicitly).

#### Required scope for JWT authorization

Introduced in Tableau Cloud June 2022 (API 3.16) and Tableau Server 2022.3 (API 3.17).

```
tableau:datasources:download
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

The data source content in `.tdsx` format (`Content-Type: application/octet-stream`).

The response will have the following content disposition header:

`Content-Disposition: name="tableau_datasource"; filename="datasource-filename"`

#### Version

Version 2.0 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>403</td><td>403028</td><td>Read forbidden</td><td>A non-administrator user attempted to download a data source, but the caller doesn't have <span class="api-command-ref">Read</span> permission.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404004</td><td>Data source not found</td><td>The data source ID in the URI doesn't correspond to an existing data source.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">GET</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

#### Example

`curl "http://MY-SERVER/api/3.29/sites/9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d/datasources/1a2a3b4b-5c6c-7d8d-9e0e-1f2f3a4a5b6b/content" -X GET -H "X-Tableau-Auth:12ab34cd56ef78ab90cd12ef34ab56cd" > my-datasource.tdsx`

The response is a file that contains the data source.

## Download Data Source Encrypted Keychain

Gets an encrypted version of the embedded credentials from the data source. These credentials can only be migrated to the linked destination Tableau Cloud or Tableau Server.

Before you use this method, you must create public and private keys for resources with embedded credentials. For more information, see [Migrate Workbooks and Data Sources with Embedded Credentials](https://help.tableau.com/current/server/en-us/cmt-migration_embedded_credentials.htm).

**Version:** Available in API 3.23 (Tableau Cloud June 2024/ Tableau Server 2024.2) and later. _[Version Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm)_

**License:** No additional license required.

**Permissions:** This method can only be called by Tableau Cloud and Tableau Server admins.   _[Permissions Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm)_

**JWT Access Scope:** tableau:embedded\_credentials:download

- Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).
- For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### URI

POST /api/api-version/sites/site-luid/datasources/datasource-luid/retrieveKeychain

#### URI Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID for the site.</td></tr><tr><td><span class="api-placeholder">datasource-luid</span></td><td>The LUID of the data source to download the encrypted keychain from.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <destinationSiteUrlNamespace>site1</destinationSiteUrlNamespace>
  <destinationSiteLuid>d56023b5-8f8b-4241-aa74-8974ced85827</destinationSiteLuid>
  <destinationServerUrl>http://example.com</destinationServerUrl>
</tsRequest>
```

```
{
  "destinationSiteUrlNamespace": "site1",
  "destinationSiteLuid": "d56023b5-8f8b-4241-aa74-8974ced85827",
  "destinationServerUrl": "http://localhost"
}
```

#### Request Attributes

<table class="api-parameters-table">
                                <colgroup>
                                    <col class="api-parameters-table-col-1">
                                    <col>
                                </colgroup>
                                <tbody>
                                    <tr>
                                        <td><code>destinationSiteUrlNamespace</code>
                                        </td>
                                        <td>
                                            <p>
								(Required) The site name on Tableau Cloud.</p>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><code>destinationSiteLuid</code>
                                        </td>
                                        <td>(Required) &nbsp;The site ID on Tableau Cloud.</td>
                                    </tr>
                                    <tr>
                                        <td><code>destinationServerUrl</code>
                                        </td>
                                        <td>
                                            <p>(Required) The destination Tableau Cloud URL.</p>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>

#### cURL Request Example

```
curl --location "https://example.org/api/3.24/sites/7a2f773d-4a9f-496e-afc6-a60517cb1b86/datasources/1a2a3b4b-5c6c-7d8d-9e0e-1f2f3a4a5b6b/retrieveKeychain" -X POST --header "Content-Type: application/xml"  --header "X-Tableau-Auth: nbQAstTxTHuBlcMlXZ3QKg|LXn5aiYcffck999kgpOPrQft5JkvRsYg|7a2f773d-4a9f-496e-afc6-a60517cb1b86"  --data "<tsRequest> <destinationSiteUrlNamespace>site1</destinationSiteUrlNamespace><destinationSiteLuid>9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d</destinationSiteLuid><destinationServerUrl>http://example.com</destinationServerUrl></tsRequest>"
```

#### Response Code

200

#### Response Body

```
<tsResponse>
   <associatedUserLuidList/>
   <encryptedKeychainList>
     <encryptedKeychain>BADsJ5lBKho2Tdqqbo7txS8IyKgNw5FnJud0etCHJLhBUurgIRHk3g5AeMQg6KHBw+6nwNIDEd65MKi76DLd5aIMhQC5aLCR4NE7R2gp7JbxLo+nOMGnfDQm5XekJVpLQGfY53GIX52ED2iTfOQ0yRNbnPV4djT0z23rosG0gpmqXV/py5okFzVW4wx8RisnZdvv+SAlv222jVhksX1w5A6HB3Bs45BeWfpwrOnHwnNoWUGwHuu4iGlyE7m65RlATZN+fvDGOFN1zU2lXaSZyWqRKiWkD+oCS5wRNtJ6lGz7RnesKvH6QEL9sT8cXA1ZOEA531xNAv9rjazEP5BssIdA1GcJ5J7zar5xxC68qm3cz3MkndyqWXZrf0vWPgwysUHEpWn60oDG/8/xG6c0Eigh4gwE+dA+NF1L2q9VyhVr8+AzJ7vatf95LDwAuRT43G3Q+WApx9qBPXco15pKjwy00rHPgn4cRtu+unwh6d3gIh6AbK6X++U/vV/Ktpe31lSZmV8eHPeTNfdCrGOT9ozZhF5oKhsBZyFrVY7Wtf1YcXawh3bvtZxg9d8a2mKNXDeaF+uJrpI43aFa4KrJKdfvDpq2k0aJhL1QNxWSFBYw0tPJX/rhKAeOHHY2K44Wh5JNWwL+x1uYap93IK303sJ13hV0jXW7nXUhfIW7o5iUtbYWrpCvVwubZLf4U5Y=</encryptedKeychain>
   </encryptedKeychainList>
</tsResponse>
```

```
{
  "associatedUserLuidList": [],
  "encryptedKeychainList": {
    "encryptedKeychain": "BADsJ5lBKho2Tdqqbo7txS8IyKgNw5FnJud0etCHJLhBUurgIRHk3g5AeMQg6KHBw+6nwNIDEd65MKi76DLd5aIMhQC5aLCR4NE7R2gp7JbxLo+nOMGnfDQm5XekJVpLQGfY53GIX52ED2iTfOQ0yRNbnPV4djT0z23rosG0gpmqXV/py5okFzVW4wx8RisnZdvv+SAlv222jVhksX1w5A6HB3Bs45BeWfpwrOnHwnNoWUGwHuu4iGlyE7m65RlATZN+fvDGOFN1zU2lXaSZyWqRKiWkD+oCS5wRNtJ6lGz7RnesKvH6QEL9sT8cXA1ZOEA531xNAv9rjazEP5BssIdA1GcJ5J7zar5xxC68qm3cz3MkndyqWXZrf0vWPgwysUHEpWn60oDG/8/xG6c0Eigh4gwE+dA+NF1L2q9VyhVr8+AzJ7vatf95LDwAuRT43G3Q+WApx9qBPXco15pKjwy00rHPgn4cRtu+unwh6d3gIh6AbK6X++U/vV/Ktpe31lSZmV8eHPeTNfdCrGOT9ozZhF5oKhsBZyFrVY7Wtf1YcXawh3bvtZxg9d8a2mKNXDeaF+uJrpI43aFa4KrJKdfvDpq2k0aJhL1QNxWSFBYw0tPJX/rhKAeOHHY2K44Wh5JNWwL+x1uYap93IK303sJ13hV0jXW7nXUhfIW7o5iUtbYWrpCvVwubZLf4U5Y="
  }
}
```

#### Errors

<table class="api-error-table">
                        <colgroup>
                            <col class="api-error-table-col-1">
                            <col class="api-error-table-col-2">
                            <col class="api-error-table-col-3">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <th>HTTP status</th>
                                <th><code>error</code> Code</th>
                                <th>Condition</th>
                                <th>Details</th>
                            </tr>
                            <tr>
                                <td>400</td>
                                <td>400000</td>
                                <td>Bad Request</td>
                                <td>The content of the request body is missing or incomplete, or contains malformed XML.</td>
                            </tr>
                            <tr>
                                <td>401</td>
                                <td>401002</td>
                                <td>Unauthorized Access</td>
                                <td>
                                    <p>The authentication token provided in the request header was invalid or has expired.</p>
                                </td>
                            </tr>
                            <tr>
                                <td>403</td>
                                <td>403054</td>
                                <td>Unauthorized Access</td>
                                <td>A non-administrator user attempted to get data source revision information, but the caller doesn't have sufficient permissions.</td>
                            </tr>
                            <tr>
                                <td>404</td>
                                <td>404000</td>
                                <td>Site not found</td>
                                <td>The site ID in the URI doesn't correspond to an existing site.</td>
                            </tr>
                            <tr>
                                <td>404</td>
                                <td>404004
                    </td>
                                <td>Data source not found</td>
                                <td>The data source ID in the URI doesn't correspond to an existing data source.</td>
                            </tr>
                            <tr>
                                <td>405</td>
                                <td>405000</td>
                                <td>Invalid request method</td>
                                <td>Request type was not <span class="api-command-ref">POST</span>.</td>
                            </tr>
                        </tbody>
                    </table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Download Data Source Revision

Downloads a specific version of a data source prior to the current one in `.tdsx` format. To down load the current version of a data source use the [Download Data Source](#download_data_source) method.

**Note:** This method is available only if version history is enabled for the specified site. For more information, see [Maintain a History of Revisions](https://help.tableau.com/current/server/en-us/help.htm#revision_history_maintain.htm) in the Tableau Server Help.

#### URI

GET /api/api-version/sites/site-id/datasources/datasource-id/revisions/revision-number/content

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to download.</td></tr><tr><td><span class="api-placeholder">revision-number</span></td><td>The revision number of the data source to download. To determine what versions are available, call <a href="#get_data_source_revisions">Get Data Source Revisions</a>.</td></tr></tbody></table>

#### Request Body

None

#### Permissions

Tableau Server users who are site administrators can download data source revisions on the site that they are administrators for. Users who are not server administrators or site administrators can get data source revisions if they have all of the following:

- A site role of ExplorerCanPublish.
- Read (view), Write (save), and Download (save as) permissions for the specified data source.
- Save (write) permissions for the project that contains the data source.

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:content:read
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

The data source content in `.tdsx` format (`Content-Type: application/octet-stream`).

The response will have the following content disposition header:

`Content-Disposition: name="tableau_datasource"; filename="datasource-filename"`

#### Version

Version 2.3 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>403</td><td>403028</td><td>Read forbidden</td><td>A non-administrator user attempted to download a data source, but the caller doesn't have required permissions.</td></tr><tr><td>403</td><td>403053</td><td>Version history not enabled</td><td>version history is not enabled for the specified site.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404004</td><td>Data source not found</td><td>The data source ID in the URI doesn't correspond to an existing data source.</td></tr><tr><td>404</td><td>404024</td><td>Data source revision not found</td><td>The revision number in the URI doesn't correspond to an existing data source revision.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">GET</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Get Data Source Revisions

Returns a list of revision information (history) for the specified data source.

**Note:** This method is available only if version history is enabled for the specified site. For more information, see [Maintain a History of Revisions](https://help.tableau.com/current/server/en-us/help.htm#revision_history_maintain.htm) in the Tableau Server Help.

To get a specific version of the data source from revision history, use the [Download Data Source Revision](#download_data_source_revision) method.

#### URI

GET /api/api-version/sites/site-id/datasources/datasource-id/revisions

GET /api/api-version/sites/site-id/datasources/datasource-id/revisions?pageSize\=page-size&pageNumber\=page-number

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The ID of the site that contains the data source to get revisions for.</td></tr><tr><td><span class="api-placeholder">datasource-id</span></td><td>The ID of the data source to get revisions for.</td></tr><tr><td><span class="api-placeholder">page-size</span></td><td>(Optional) The number of items to return in one response. The minimum is 1. The maximum is 1000. The default is 100. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_paging.htm">Paginating Results</a>.</td></tr><tr><td><span class="api-placeholder">page-number</span></td><td>(Optional) The offset for paging. The default is 1. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_paging.htm">Paginating Results</a>.</td></tr></tbody></table>

#### Request Body

None

#### Permissions

Tableau Server users who are site administrators can get data source revisions on the site that they are administrators for. Users who are not server administrators or site administrators can get data source revisions if they have all of the following:

- A site role of ExplorerCanPublish.
- Read (view), Write (save), and Download (save as) permissions for the specified data source.
- Save (write) permissions for the project that contains the data source.

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:content:read
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

```
<tsResponse>
  <pagination pageNumber="pageNumber" pageSize="page-size"
    totalAvailable="total-available" />
  <revisions>
    <revision revisionNumber="1" publishedAt="date" deleted="false">
      <publisher id="publisher-id" name="publisher-name"/>
    </revision>
    <revision revisionNumber="2" publishedAt="date" deleted="false">
    </revision>
    <revision revisionNumber="3" publishedAt="date" deleted="false" current="true" sizeInBytes="size>
      <publisher id="publisher-id" name="publisher-name"/>
    </revision>
  </revisions>
</tsResponse>
```

If the revision element includes the attribute `deleted="true"`, the data source has been deleted and cannot be downloaded using the [Download Data Source Revision](#download_data_source_revision) method.

If a user has been deleted from the site, no `<publisher>` element is included in the `<revision>` element.

#### Version

Version 2.3 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table">
                                <colgroup>
                                    <col class="api-error-table-col-1">
                                    <col class="api-error-table-col-2">
                                    <col class="api-error-table-col-3">
                                    <col>
                                </colgroup>
                                <tbody>
                                    <tr>
                                        <th>HTTP status</th>
                                        <th><code>error</code> Code</th>
                                        <th>Condition</th>
                                        <th>Details</th>
                                    </tr>
                                    <tr>
                                        <td>400</td>
                                        <td>400006</td>
                                        <td>Invalid page number</td>
                                        <td>
                                    The page number parameter is not an integer, is less than one, or is greater than the final page
                                    number for data sources at the requested page size.
                                </td>
                                    </tr>
                                    <tr>
                                        <td>400</td>
                                        <td>400007</td>
                                        <td>Invalid page size</td>
                                        <td>The page size parameter is not an integer, or is less than one.</td>
                                    </tr>
                                    <tr>
                                        <td>403</td>
                                        <td>403014</td>
                                        <td>Page size limit exceeded</td>
                                        <td>The specified page size is larger than the maximum page size.</td>
                                    </tr>
                                    <tr>
                                        <td>403</td>
                                        <td>403053</td>
                                        <td>Version history not enabled</td>
                                        <td>version history is not enabled for the specified site.</td>
                                    </tr>
                                    <tr>
                                        <td>403</td>
                                        <td>403054</td>
                                        <td>A non-administrator user attempted to get data source revision information, but the caller doesn't have sufficient permissions.</td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td>404000</td>
                                        <td>Site not found</td>
                                        <td>The site ID in the URI doesn't correspond to an existing site.</td>
                                    </tr>
                                    <tr>
                                        <td>404</td>
                                        <td></td>
                                        <td>Data source not found</td>
                                        <td>The data source ID in the URI doesn't correspond to an existing data source.</td>
                                    </tr>
                                    <tr>
                                        <td>405</td>
                                        <td>405000</td>
                                        <td>Invalid request method</td>
                                        <td>Request type was not <span class="api-command-ref">GET</span>.</td>
                                    </tr>
                                </tbody>
                            </table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Publish Data Source

Publishes a data source on the specified site, or appends data to an existing data source.

To make other changes to a published data source, call [Update Data Source](#update_data_source) or [Update Data Source Connection](#update_data_source_connection).

**Version**: Available in API 2.0 and later.

**License**: Available for Tableau Server and Tableau Cloud.

**Permissions**: You can publish a data source if you have implicit or explicit Publish permissions for the data source, or are a Tableau administrator.

Note: The `queryTaggingEnabled` attribute is returned only for administrator users.

**Access Scope**: `tableau:datasources:create`

For more information, see [Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm), [Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm), [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud), and access scopes for [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows,](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm) or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

This method is used in two ways. You can call it to publish a data source in a single request. To do that, you include the content of the data source file in the body of the request. The maximum size of a file that can be published in a single request is 64 MB. If you want to avoid having the publishing process time out, you can use the _asJob_ parameter to make data source publication asynchronous.

Alternatively, you can publish a data source in multiple parts. To do that, you initiate a file upload by calling [Initiate File Upload](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_publishing.htm#initiate_file_upload), send portions of the file to the server using [Append to File Upload](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_publishing.htm#append_to_file_upload), and then commit the upload by calling Publish Data Source. In this case, Publish Data Source doesn't contain the file to publish.

**Extracts with multiple table options**  
Starting in v2021.4, you can publish multi table Hyper extract files created using the [Hyper API](https://help.tableau.com/current/api/hyper_api/en-us/docs/hyper_api_create_update.html). The data must include a single [fact table](https://en.wikipedia.org/wiki/Fact_table) containing the foreign keys that relate the tables to each other. The Hyper API infers the data object model, but does not perform any validation, such as referential integrity checking. If the Hyper API can’t infer the data object model of a Hyper extract, for instance, because there is more than one fact table, then attempting to publish the extract will fail. Prior to v2021.4, there was no way to append data to an extract with multiple tables using the REST API.

**Data Sources stored locally**  
When you publish a data source from your local computer to the server, you must make sure that the server has all the components that are required in order for other users to see and interact with the data source. For example, if the data source is based on an Excel spreadsheet, you typically publish a packaged data source (`.tdsx` file) that contains all the components for that data source.

**Replace data source**  
Starting in version 2025.1, you can use the replace parameter. You can include `overwrite`, `append`, and `replace` in a single request, but only one of these parameters can be set to true. If more than one is set to true, the request returns an HTTP 400 error.

**Working with Parquet files**  
\- When publishing a Parquet file to a data source through a live-to-Hyper connection, the files are converted to Hyper files. You may want to publish a copy of your original Parquet file to retain that data in its native format.  
\- A data source with a live-to-Hyper connection to data in a Hyper file converted from Parquet can only have a single connection.  
\- When incrementally updating that data from that connection, using the Update Hyper in Data Source method, the Parquet file is not converted to Hyper.

**Composed data sources and extended data sources**  
Starting in REST API version 3.29 (Cloud 262 and Server 2026.2), you can publish composed and extended data sources.  
  
When you publish a composed data source, you must include a `parentDataSourceUrls` element in addition to the `.tds` file so the composed data source is correctly linked to its parents. Include one entry for every published data source that is a direct parent of the composed data source. These correspond to the `datasource-url` tags serialized in the `.tds` file's data source tree. Include only the immediate parent data sources that the data source you are publishing depends on.  
  
When you publish an extended data source, include the `.tds` file as usual; no `parentDataSourceUrls` element is required.

For more information, see [Publishing Resources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_publish.htm).

#### URI

POST /api/api-version/sites/site-luid/datasources

POST /api/api-version/sites/site-luid/datasources?overwrite=overwrite-flag&asJob=asJob-value

POST /api/api-version/sites/site-luid/datasources?append=append-flag

POST /api/api-version/sites/site-luid/datasources?uploadSessionId=upload-session-id&datasourceType=datasource-file-type&overwrite=overwrite-flag&append=append-flag&replace=replace-flag

#### URI Parameter Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">api-version</span>
                                </td>
                                <td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">site-luid</span>
                                </td>
                                <td>The LUID of the site to publish to.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">overwrite-flag</span>
                                </td>
                                <td><span class="api-command-ref">true</span> to overwrite a data source that has the same name, or <span class="api-command-ref">false</span>
                                        to fail if the specified data source already exists. The default is <span class="api-command-ref">false</span>. If <span class="api-placeholder">overwrite-flag</span>
                                        is set to <span class="api-command-ref">true</span> but the data source doesn't already exist, the operation succeeds.
                                        <p>You can include both the  <span class="api-command-ref">overwrite</span> and <span class="api-command-ref">append</span> parameters in a request, but they cannot both be <span class="api-command-ref">true.</span></p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">replace-flag</span>
                                </td>
                                <td>(New in 2025.1) A boolean value (<strong>true </strong>or <strong>false</strong>). Set to <strong>true </strong>to replace the data in an existing data source. The default is <strong>false</strong>.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">asJob-value</span>
                                </td>
                                <td>A Boolean value that is used to publish data sources asynchronously. If you set this value to <i>false</i> (the default), the publishing process runs as a synchronous process. If a data source is very large, the process might time out before it finishes. If you set this value to <i>true</i>, the process runs asynchronously, and a job will start to perform the publishing process and return the job ID. You can check the status of the import job by calling <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_jobs_tasks_and_schedules.htm#query_job">Query Job</a>.
									</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">append-flag</span>
                                </td>
                                <td><span class="api-command-ref">true</span> to append the data being published to an existing data source that has the same name. The default
                                        is <span class="api-command-ref">false</span>. If <span class="api-placeholder">append-flag</span>
                                        is set to <span class="api-command-ref">true</span> but the data source doesn't already exist, the operation fails.
                                <p>
									In order to append data to a published data source on Tableau Server, both the source file and the published file must be
									an extract with the file extension <code>.hyper</code> or <code>.tde</code>. The schema of the source and the published extract must match.
								</p><p>If an extract was stored using the multiple tables option, you can't append data to it.</p><p>You can include both the  <span class="api-command-ref">overwrite</span> and <span class="api-command-ref">append</span> parameters in a request, but they cannot both be <span class="api-command-ref">true.</span></p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">upload-session-luid</span>
                                </td>
                                <td>If you are calling this method to commit a file that was uploaded in parts, this value contains the upload session LUID that was generated by a call to
                                        <a href="https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_publishing.htm#initiate_file_upload"><span class="api-command-ref">Initiate File Upload</span></a>. If this value is not included, the server assumes
                                        that the body of the request contains the file to be published.
                                    </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-file-type</span>
                                </td>
                                <td><span class="api-command-ref">hyper</span>, <span class="api-command-ref">tds</span>, <span class="api-command-ref">tdsx</span>, or <span class="api-command-ref">tde</span> the kind of file
                                        that you are uploading. This value is required if you are calling <span class="api-command-ref">Publish Data Source</span> in order to
                                        commit a file that was previously uploaded using <span class="api-command-ref">Append to File Upload</span>. The value is not used if you upload a file in the
                                        body of the request.
                                    </td>
                            </tr>
                        </tbody>
                    </table>

#### Request Body

The content type in the header of requests to publish a data source must use the mixed multipart content type with a boundary string definition, in the form of: `Content-Type: multipart/mixed; boundary=boundary-string`.

**Publishing a file in the request body**

```
--boundary-string
Content-Disposition: name="request_payload"
Content-Type: text/xml
<tsRequest>
	<datasource
	name="datasource-name"
	useRemoteQueryAgent="remote-query-agent-flag"
	description="datasource-description">
	<connectionCredentials
	name="connection-username"
	password="connection-password"
	embed="embed-flag"
	oAuth="oauth-flag" />
	<project
	id="project-id" />
	<parentDataSourceUrls>parent-datasource-url</parentDataSourceUrls>
	</datasource>
</tsRequest>
--boundary-string
Content-Disposition: name="tableau_datasource"; filename="SALES.TDSX"
Content-Type: application/octet-stream
content-of-datasource-file
--boundary-string--
```

**Committing a file previously uploaded**

```
--boundary-string
Content-Disposition: name="request_payload"
Content-Type: text/xml
<tsRequest>
	<datasource
	name="datasource-name" >
	<connectionCredentials
	name="connection-username"
	password="connection-password"
	embed="embed-flag"
	oAuth="oauth-flag" />
	<project
	id="project-id" />
	<parentDataSourceUrls>parent-datasource-url</parentDataSourceUrls>
	</datasource>
</tsRequest>
	--boundary-string--
```

**Publishing a file in the request body**

```
Content-Length: 16301
Content-Type: multipart/form-data; boundary=----------------------my_boundary_string
----------------------my_boundary_string
Content-Disposition: form-data; name="part1.json"
Content-Type: application/json
{
  "datasource": {
	"name": "datasource-name",
	"useRemoteQueryAgent": "remote-query-agent-flag",
	"description": "datasource-description",
	"connectionCredentials": {
	"name": "connection-username",
	"password": "connection-password",
	"embed": "embed-flag",
	"oAuth": "oauth-flag"
	},
  "project": {
	"id": "project-id"
	},
  "parentDataSourceUrls": [
  "parent-datasource-url"
   ]
   }
 }
 ----------------------my_boundary_string
Content-Disposition: form-data; name="datasource.tdsx"
Content-Type: application/octet-stream
content-of-datasource-file
----------------------my_boundary_string--
```

**Committing a file previously uploaded**

```
Content-Length: 16301
Content-Type: multipart/form-data; boundary=----------------------my_boundary_string
----------------------my_boundary_string
Content-Disposition: form-data; name="part1.json"
Content-Type: application/json
{
  "datasource": {
	"name": "datasource-name",
	"connectionCredentials": {
	"name": "connection-username",
	"password": "connection-password",
	"embed": "embed-flag",
	"oAuth": "oauth-flag"
	},
  "project": {
	"id": "project-id"
	},
  "parentDataSourceUrls": [
	"parent-datasource-url"
	]
  }
}
----------------------my_boundary_string--
```

#### Request Attributes

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-extra-wide">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">boundary-string</span>
                                </td>
                                <td>(Required) A string of characters that is guaranteed to be unique within the body of the request, and that is used to delimit sections of the request body. This value
                                        must be declared as a header that has this format:
                                        <p><code>Content-type: multipart/mixed; boundary=boundary-string</code></p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-name</span>
                                </td>
                                <td>(Required) The name to assign to the data source when it is saved on the server.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">remote-query-agent-flag</span>
                                </td>
                                <td>(Optional) When <code>true</code>, this flag will <a href="https://help.tableau.com/current/online/en-us/to_enable_bridge_live_connections.htm" target="_blank">allow your Tableau Cloud site to use Tableau Bridge clients</a>. Bridge allows you to maintain data sources with live connections to supported on-premises data sources.
							</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-description</span>
                                </td>
                                <td>(Optional) A description of the data source.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">connection-username</span>
                                </td>
                                <td>(Optional) If the data source connection requires credentials, the <span class="api-command-ref">&lt;connectionCredentials&gt;</span> elements is included and this attribute specifies the connection username. If the element is included but is not required, the server ignores the element and its attributes.<p>If your auth type allows secrets to be passed as generic username and password variables, use this attribute for the appropriate secret, such as client id. (Example auth types include 2-legged OAuth, like Service Principal OAuth with Databricks and Client Credentials OAuth with Snowflake.)</p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">connection-password</span>
                                </td>
                                <td>(Optional) If the data source connection requires credentials, the <span class="api-command-ref">&lt;connectionCredentials&gt;</span> elements is included and this attribute specifies the connection password. If the element is included but is not required, the server ignores the element and its attributes.<p>If your auth type allows secrets to be passed as generic username and password variables, use this attribute for the appropriate secret, such as client secret. (Example auth types include 2-legged OAuth, like Service Principal OAuth with Databricks and Client Credentials OAuth with Snowflake.)</p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">embed-flag</span>
                                </td>
                                <td>(Optional) If the data source connection requires credentials, the <span class="api-command-ref">&lt;connectionCredentials&gt;</span> element is included. Setting this attribute to <span class="api-command-ref">true</span> instructs the server to save the credentials.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">oauth-flag</span>
                                </td>
                                <td>(Optional) If the data source connection is configured to use OAuth, set this to <code class="api-command-ref">true</code> to specify
									that the value of the <span class="api-command-ref">name</span> attribute in the
									<span class="api-command-ref">connectionCredentials</span> element is an OAuth username. In that case, no password is
									required and the value of the <span class="api-command-ref">embed</span> attribute specifies whether to embed the OAuth
									credential with the data source.<p>If your auth type allows secrets to be passed as generic username and password variables, set the <span class="api-command-ref">oAuth</span> attribute to <code>false</code>. (Example auth types include 2-legged OAuth, like Service Principal OAuth with Databricks and Client Credentials OAuth with Snowflake.)</p><p>For more information on OAuth, see the OAuth Connections section of the <a href="https://help.tableau.com/current/online/en-us/protected_auth.htm" target="_blank">Tableau Cloud</a> or <a href="https://help.tableau.com/current/server/en-us/protected_auth.htm" target="_blank">Tableau Server</a> Product Help.</p></td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">project-id</span>
                                </td>
                                <td>The LUID of the project to assign the data source to. If the project is not specified, the data source will be published to the default project.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-file-name</span>
                                </td>
                                <td>The file name (including extension) of the data source file to upload. This attribute is used in the request body only if the
                                        request also includes the content of the data source file; it is not used if you are committing a file uploaded using
                                        previous requests.
                                    </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">	content-of-datasource-file</span>
                                </td>
                                <td>The content of the data source file, if the request includes the file. The maximum size of a file that can be uploaded in one call is 64&nbsp;MB.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">askDataEnablement</span>
                                </td>
                                <td>
									This attribute is not available in API 3.12 and later (Tableau Cloud September 2021 / Server 2021.3).
								</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">parentDataSourceUrls</span>
                                </td>
                                <td>The name (URL) of the immediately referenced published data source that the data source being published depends on. For a composed data source, you must include one entry for each top-level parent data source in the data model.
</td>
                            </tr>
                        </tbody>
                    </table>

#### cURL Example

`curl "http://MY_SERVER/api/3.4/sites/ff2a8360-3c2b-4b05-a793-7607c602e1fb/datasources" -X POST -H "X-Tableau-Auth:6fSulU7ET8yjpHteQj56MQ|LrkEdTHcmPkWFcD8wOEy29hlVXm8iPo4" -H "Content-Type: multipart/mixed;" -F "request_payload=@publish-datasource.xml" -F "tableau_datasource=@data-source.tds"`

**Content of publish-datasource.xml**:

```
<tsRequest>
  <datasource name="datasource1" description="This is a data source named datasource1." >
    <project id="522dc5c5-e1da-47b9-8e07-f02929ff5ceb" />
  </datasource>
</tsRequest>
```

#### Response Code

201

#### Response Body

```
<tsResponse>
  <datasource
	id="75b71d2f-e8d3-42af-b654-d953659326ee"
	name="Sales"
	contentUrl="mySite"
	description="Sales Data Source"
	useRemoteQueryAgent="True"
	webpageUrl="https://my_server/#/datasources/222"
	type="excel-direct"
	createdAt="2016-02-12T23:36:09Z"
	updatedAt="2020-12-16T15:33:03Z"
	isCertified="False"
	certificationNote="This is a certification note."
	encryptExtracts="True">
	  <project
		id="56c86f04-b834-4a08-a561-86497bb4b2df"
		name="Visualization"/>
	  <owner id="20148c74-7818-4eb8-b2a1-9f3f5f582613"/>
	  <tags/>
  </datasource>
</tsResponse>
```

```
{
  "datasource": {
	"id": "75b71d2f-e8d3-42af-b654-d953659326ee",
	"name": "Sales",
	"contentUrl": "mySite",
	"description": "Sales Data Source",
	"useRemoteQueryAgent": "True",
	"webpageUrl": "https://my_server/#/datasources/222",
	"type": "excel-direct",
	"createdAt": "2016-02-12T23:36:09Z",
	"updatedAt": "2020-12-16T15:33:03Z",
	"isCertified": "False",
	"certificationNote": "This is a certification note.",
	"encryptExtracts": "True",
	"project": {
	  "id": "56c86f04-b834-4a08-a561-86497bb4b2df",
	  "name": "Visualization"
	},
	"owner": {
	  "id": "20148c74-7818-4eb8-b2a1-9f3f5f582613"
	},
	"tags": []
  }
}
```

The `createdAt` and `updatedAt` attribute values are returned in UTC format (YYYY-MM-DDTHH:MM:SSZ).

#### Response Headers

`Location: /api/3.29/sites/site-id/datasources/id-from-server`

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The request message is missing or incomplete, or contains malformed XML. Make sure that the <span class="api-command-ref">Content-Length</span> value is set.</td></tr><tr><td>400</td><td>400000</td><td>Missing data source</td><td>There is no attachment in the request for the data source.</td></tr><tr><td>400</td><td>400008</td><td>Invalid <span class="api-command-ref">overwrite</span> value</td><td>The <span class="api-command-ref">overwrite</span> parameter must be set to <span class="api-command-ref">true</span> or <span class="api-command-ref">false</span>.</td></tr><tr><td>400</td><td>400008</td><td>Invalid <span class="api-command-ref">append</span> value</td><td>The <span class="api-command-ref">append</span> parameter must be set to <span class="api-command-ref">true</span> or <span class="api-command-ref">false</span>.</td></tr><tr><td>400</td><td>400008</td><td>Invalid <span class="api-command-ref">embed</span> value</td><td>The request body contains a <span class="api-command-ref">&lt;connectionCredentials&gt;</span> element and it has an <span class="api-command-ref">embed</span>&nbsp;attribute whose value is not <span class="api-command-ref">true</span>&nbsp;or&nbsp;<span class="api-command-ref">false</span>.</td></tr><tr><td>400</td><td>400010</td><td>Invalid data source filename</td><td>The name of the data source file did not end with the suffix <code>.hyper</code>, <code>.tds</code>, <code>.tdsx</code>, or <code>.tde</code>.</td></tr><tr><td>400</td><td>400010</td><td>Missing or invalid file type</td><td>The request included an <span class="api-command-ref">uploadSessionId</span>&nbsp;parameter but no file type, or the file type was something other than <span class="api-command-ref">hyper</span>, <span class="api-command-ref">tds</span>, <span class="api-command-ref">tdsx</span>, or <span class="api-command-ref">tde</span>.</td></tr><tr><td>400</td><td>400010</td><td>Unexpected attachments</td><td>The message had both a <span class="api-placeholder">uploadSessionId</span> parameter and an attachment, or the message contained more than one attachment.</td></tr><tr><td>400</td><td>400011</td><td>Publishing error</td><td>The data source could not be published for some other reason than those specified earlier.</td></tr><tr><td>400</td><td>400011</td><td>Bad Request</td><td>The request is invalid. This can occur if more than one of the conflict resolution parameters (<strong>overwrite</strong>, <strong>append</strong>, or <strong>replace</strong>) is set to <code>true</code>. Only one of these parameters can be true in a single request.</td></tr><tr><td>400</td><td>400019</td><td>Malformed request body</td><td>The request message is missing or incomplete, or contains malformed XML. Make sure that the <span class="api-command-ref">Content-Length</span> value is set.</td></tr><tr><td>400</td><td>400055</td><td>Incompatible <span class="api-command-ref">overwrite</span> and <span class="api-command-ref">append</span> values</td><td>The <span class="api-command-ref">overwrite</span> and <span class="api-command-ref">append</span> parameter cannot both be set to <span class="api-command-ref">true</span>.</td></tr><tr><td>400</td><td>400129</td><td>Invalid Ask Data enablement</td><td>The enablement setting in the request body is not valid for the current server configuration.</td></tr><tr><td>403</td><td>403007</td><td>Insufficient publishing permission</td><td>A non-administrator user attempted to publish a data source, but the caller doesn't have sufficient project permissions.</td></tr><tr><td>403</td><td>403007</td><td>Unlicensed publishing forbidden</td><td>A non-administrator user who is unlicensed attempted to publish a data source. This is disallowed for all projects (including the default project).</td></tr><tr><td>403</td><td>403007</td><td>Overwrite forbidden</td><td>A data source with the specified name already exists and the <span class="api-command-ref">overwrite</span> parameter was not set to <span class="api-command-ref">true</span>.</td></tr><tr><td>403</td><td>403007</td><td>Problem connecting to data source</td><td>There was a problem connecting to a data source.&nbsp;This can be due to missing or invalid connection credentials or because the referenced data source is not available on the server.</td></tr><tr><td>403</td><td>403008</td><td>Insufficient storage quota</td><td>The data source could not be published because there is not enough storage remaining on the server to accommodate its size.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404004</td><td>Data source not found</td><td>The <span class="api-command-ref">append</span> parameter is <span class="api-command-ref">true</span> but the data source name specified in the request body does not correspond to an existing data source.</td></tr><tr><td>404</td><td>404005</td><td>Project not found</td><td>The project ID in the request body doesn't correspond to an existing project on the site.</td></tr><tr><td>404</td><td>404015</td><td>File upload not found</td><td>The file upload session ID in the request body doesn't correspond to an existing file upload on the site.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">POST</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Publish Work Copy

Publishes a work copy as a data source. Send the published data source `name` and an optional `description`. The response returns the new data source LUID. A blank name is rejected.

**Version**: Available in API 3.30 (Tableau Cloud October 2026 / Server 2026.3) and later.

**License**: Data Management or Tableau+.

[...]
